# Ipopt::PenaltyLSAcceptor Class Reference

Penalty function line search. More...

`#include <IpPenaltyLSAcceptor.hpp>`

Inheritance diagram for Ipopt::PenaltyLSAcceptor:
[legend]

List of all members.

## Public Member Functions
virtual bool | InitializeImpl (const OptionsList &options, const std::string &prefix)
| InitializeImpl - overloaded from AlgorithmStrategyObject.
virtual void | Reset ()
| Reset the acceptor.
virtual void | InitThisLineSearch (bool in_watchdog)
| Initialization for the next line search.
virtual void | PrepareRestoPhaseStart ()
| Method that is called before the restoration phase is called.
virtual Number | CalculateAlphaMin ()
| Method returning the lower bound on the trial step sizes.
virtual bool | CheckAcceptabilityOfTrialPoint (Number alpha_primal)
| Method for checking if current trial point is acceptable.
virtual bool | TrySecondOrderCorrection (Number alpha_primal_test, Number &alpha_primal, SmartPtr< IteratesVector > &actual_delta)
| Try a second order correction for the constraints.
virtual bool | TryCorrector (Number alpha_primal_test, Number &alpha_primal, SmartPtr< IteratesVector > &actual_delta)
| Try higher order corrector (for fast local convergence).
virtual char | UpdateForNextIteration (Number alpha_primal_test)
| Method for ending the current line search.
virtual void | StartWatchDog ()
| Method for setting internal data if the watchdog procedure is started.
virtual void | StopWatchDog ()
| Method for setting internal data if the watchdog procedure is stopped.
Constructors/Destructors
| PenaltyLSAcceptor (const SmartPtr< PDSystemSolver > &pd_solver)
| Constructor.
virtual | ~PenaltyLSAcceptor ()
| Default destructor.
Trial Point Accepting Methods. Used internally to check certain
acceptability criteria and used externally (by the restoration phase convergence check object, for instance)
bool | IsAcceptableToCurrentIterate (Number trial_barr, Number trial_theta, bool called_from_restoration=false) const
| Checks if a trial point is acceptable to the current iterate.
## Static Public Member Functions
static void | RegisterOptions (SmartPtr< RegisteredOptions > roptions)
| Methods for OptionsList.
## Private Member Functions
Number | CalcPred (Number alpha)
| Compute predicted reduction for given step size.
Default Compiler Generated Methods
(Hidden to avoid implicit creation/calling). These methods are not implemented and we do not want the compiler to implement them for us, so we declare them private and do not define them. This ensures that they will not be implicitly created/called.
| PenaltyLSAcceptor (const PenaltyLSAcceptor &)
| Copy Constructor.
void | operator= (const PenaltyLSAcceptor &)
| Overloaded Equals Operator.
## Private Attributes
Number | resto_pred_
| When called from the restoration phase, this is the required predicted reduction.
Parameters for the penalty function line search
algorithm. Names as in the filter paper
Number | nu_init_
| Initial value of penalty parameter.
Number | nu_inc_
| Incrememt for penalty parameter.
Number | eta_
Number | rho_
Index | max_soc_
| Maximal number of second order correction steps.
Number | kappa_soc_
| Required reduction in constraint violation before trying multiple second order correction steps .
Information related to watchdog procedure
Number | reference_theta_
| Constraint violation at the point with respect to which progress is to be made.
Number | reference_barr_
| Barrier objective function at the point with respect to which progress is to be made.
Number | reference_gradBarrTDelta_
| Barrier gradient transpose search direction at the point with respect to which progress is to be made.
Number | reference_dWd_
| Two-sided product of search direction with complete Hessian.
SmartPtr< const Vector > | reference_JacC_delta_
| Product of Jacobian of equality constraint with x direction.
SmartPtr< const Vector > | reference_JacD_delta_
| Product of Jacobian of (d-s) constraint with search direction.
Number | reference_pred_
| Reference predicted reduction.
Number | watchdog_theta_
| Constraint violation at reference point.
Number | watchdog_barr_
| Barrier objective function at reference point.
Number | watchdog_pred_
| Predicted reduction to be compared with in watch dog.
Penalty parameter
Number | nu_
| Current value of the penalty parameter.
Number | last_nu_
| Value of penalty parameter at beginning of the iteration.
Strategy objective that are used
SmartPtr< PDSystemSolver > | pd_solver_

## Detailed Description

Penalty function line search.

This class implements the penalty function line search procedure as proposed by Waltz, Morales, Nocedal, Orban.

Definition at line 23 of file IpPenaltyLSAcceptor.hpp.

## Constructor & Destructor Documentation

Ipopt::PenaltyLSAcceptor::PenaltyLSAcceptor | ( | const SmartPtr< PDSystemSolver > & | pd_solver | ) |

Constructor.

The PDSystemSolver object only needs to be provided (i.e. not NULL) if second order correction or corrector steps are to be used.

virtual Ipopt::PenaltyLSAcceptor::~PenaltyLSAcceptor | ( |  | ) | `[virtual]`

Default destructor.

Ipopt::PenaltyLSAcceptor::PenaltyLSAcceptor | ( | const PenaltyLSAcceptor & |  | ) | `[private]`

Copy Constructor.

## Member Function Documentation

virtual bool Ipopt::PenaltyLSAcceptor::InitializeImpl | ( | const OptionsList & | options,
|  | const std::string & | prefix |
| ) |  |  | `[virtual]`

InitializeImpl - overloaded from AlgorithmStrategyObject.

Implements Ipopt::BacktrackingLSAcceptor.

virtual void Ipopt::PenaltyLSAcceptor::Reset | ( |  | ) | `[virtual]`

Reset the acceptor.

This function should be called if all previous information should be discarded when the line search is performed the next time. For example, this method should be called if the barrier parameter is changed.

Implements Ipopt::BacktrackingLSAcceptor.

virtual void Ipopt::PenaltyLSAcceptor::InitThisLineSearch | ( | bool | in_watchdog | ) | `[virtual]`

Initialization for the next line search.

The flag in_watchdog indicates if we are currently in an active watchdog procedure.

Implements Ipopt::BacktrackingLSAcceptor.

virtual void Ipopt::PenaltyLSAcceptor::PrepareRestoPhaseStart | ( |  | ) | `[virtual]`

Method that is called before the restoration phase is called.

Here, we can set up things that are required in the termination test for the restoration phase.

Implements Ipopt::BacktrackingLSAcceptor.

virtual Number Ipopt::PenaltyLSAcceptor::CalculateAlphaMin | ( |  | ) | `[virtual]`

Method returning the lower bound on the trial step sizes.

Implements Ipopt::BacktrackingLSAcceptor.

virtual bool Ipopt::PenaltyLSAcceptor::CheckAcceptabilityOfTrialPoint | ( | Number | alpha_primal | ) | `[virtual]`

Method for checking if current trial point is acceptable.

It is assumed that the delta information in ip_data is the search direction used in criteria. The primal trial point has to be set before the call.

Implements Ipopt::BacktrackingLSAcceptor.

virtual bool Ipopt::PenaltyLSAcceptor::TrySecondOrderCorrection | ( | Number | alpha_primal_test,
|  | Number & | alpha_primal,
|  | SmartPtr< IteratesVector > & | actual_delta |
| ) |  |  | `[virtual]`

Try a second order correction for the constraints.

If the first trial step (with incoming alpha_primal) has been reject, this tries up to max_soc_ second order corrections for the constraints. Here, alpha_primal_test is the step size that has to be used in the penalty function acceptance tests. On output actual_delta_ has been set to the step including the second order correction if it has been accepted, otherwise it is unchanged. If the SOC step has been accepted, alpha_primal has the fraction-to-the-boundary value for the SOC step on output. The return value is true, if a SOC step has been accepted.

Implements Ipopt::BacktrackingLSAcceptor.

virtual bool Ipopt::PenaltyLSAcceptor::TryCorrector | ( | Number | alpha_primal_test,
|  | Number & | alpha_primal,
|  | SmartPtr< IteratesVector > & | actual_delta |
| ) |  |  | `[virtual]`

Try higher order corrector (for fast local convergence).

In contrast to a second order correction step, which tries to make an unacceptable point acceptable by improving constraint violation, this corrector step is tried even if the regular primal-dual step is acceptable.

Implements Ipopt::BacktrackingLSAcceptor.

virtual char Ipopt::PenaltyLSAcceptor::UpdateForNextIteration | ( | Number | alpha_primal_test | ) | `[virtual]`

Method for ending the current line search.

When it is called, the internal data should be updates. alpha_primal_test is the value of alpha that has been used for in the acceptence test ealier.

Implements Ipopt::BacktrackingLSAcceptor.

virtual void Ipopt::PenaltyLSAcceptor::StartWatchDog | ( |  | ) | `[virtual]`

Method for setting internal data if the watchdog procedure is started.

Implements Ipopt::BacktrackingLSAcceptor.

virtual void Ipopt::PenaltyLSAcceptor::StopWatchDog | ( |  | ) | `[virtual]`

Method for setting internal data if the watchdog procedure is stopped.

Implements Ipopt::BacktrackingLSAcceptor.

bool Ipopt::PenaltyLSAcceptor::IsAcceptableToCurrentIterate | ( | Number | trial_barr,
|  | Number | trial_theta,
|  | bool | called_from_restoration = `false` |
| ) |  |  | const

Checks if a trial point is acceptable to the current iterate.

static void Ipopt::PenaltyLSAcceptor::RegisterOptions | ( | SmartPtr< RegisteredOptions > | roptions | ) | `[static]`

Methods for OptionsList.

Reimplemented from Ipopt::BacktrackingLSAcceptor.

void Ipopt::PenaltyLSAcceptor::operator= | ( | const PenaltyLSAcceptor & |  | ) | `[private]`

Overloaded Equals Operator.

Reimplemented from Ipopt::BacktrackingLSAcceptor.

Number Ipopt::PenaltyLSAcceptor::CalcPred | ( | Number | alpha | ) | `[private]`

Compute predicted reduction for given step size.

## Member Data Documentation

Number Ipopt::PenaltyLSAcceptor::nu_init_`[private]`

Initial value of penalty parameter.

Definition at line 147 of file IpPenaltyLSAcceptor.hpp.

Number Ipopt::PenaltyLSAcceptor::nu_inc_`[private]`

Incrememt for penalty parameter.

Definition at line 149 of file IpPenaltyLSAcceptor.hpp.

Number Ipopt::PenaltyLSAcceptor::eta_`[private]`

Definition at line 151 of file IpPenaltyLSAcceptor.hpp.

Number Ipopt::PenaltyLSAcceptor::rho_`[private]`

Definition at line 153 of file IpPenaltyLSAcceptor.hpp.

Index Ipopt::PenaltyLSAcceptor::max_soc_`[private]`

Maximal number of second order correction steps.

Definition at line 155 of file IpPenaltyLSAcceptor.hpp.

Number Ipopt::PenaltyLSAcceptor::kappa_soc_`[private]`

Required reduction in constraint violation before trying multiple second order correction steps .

Definition at line 159 of file IpPenaltyLSAcceptor.hpp.

Number Ipopt::PenaltyLSAcceptor::reference_theta_`[private]`

Constraint violation at the point with respect to which progress is to be made.

Definition at line 166 of file IpPenaltyLSAcceptor.hpp.

Number Ipopt::PenaltyLSAcceptor::reference_barr_`[private]`

Barrier objective function at the point with respect to which progress is to be made.

Definition at line 169 of file IpPenaltyLSAcceptor.hpp.

Number Ipopt::PenaltyLSAcceptor::reference_gradBarrTDelta_`[private]`

Barrier gradient transpose search direction at the point with respect to which progress is to be made.

Definition at line 172 of file IpPenaltyLSAcceptor.hpp.

Number Ipopt::PenaltyLSAcceptor::reference_dWd_`[private]`

Two-sided product of search direction with complete Hessian.

Definition at line 174 of file IpPenaltyLSAcceptor.hpp.

SmartPtr<const Vector> Ipopt::PenaltyLSAcceptor::reference_JacC_delta_`[private]`

Product of Jacobian of equality constraint with x direction.

Definition at line 176 of file IpPenaltyLSAcceptor.hpp.

SmartPtr<const Vector> Ipopt::PenaltyLSAcceptor::reference_JacD_delta_`[private]`

Product of Jacobian of (d-s) constraint with search direction.

Definition at line 178 of file IpPenaltyLSAcceptor.hpp.

Number Ipopt::PenaltyLSAcceptor::reference_pred_`[private]`

Reference predicted reduction.

If positive, then it is used in watch dog.

Definition at line 181 of file IpPenaltyLSAcceptor.hpp.

Number Ipopt::PenaltyLSAcceptor::watchdog_theta_`[private]`

Constraint violation at reference point.

Definition at line 183 of file IpPenaltyLSAcceptor.hpp.

Number Ipopt::PenaltyLSAcceptor::watchdog_barr_`[private]`

Barrier objective function at reference point.

Definition at line 185 of file IpPenaltyLSAcceptor.hpp.

Number Ipopt::PenaltyLSAcceptor::watchdog_pred_`[private]`

Predicted reduction to be compared with in watch dog.

Definition at line 187 of file IpPenaltyLSAcceptor.hpp.

Number Ipopt::PenaltyLSAcceptor::nu_`[private]`

Current value of the penalty parameter.

Definition at line 193 of file IpPenaltyLSAcceptor.hpp.

Number Ipopt::PenaltyLSAcceptor::last_nu_`[private]`

Value of penalty parameter at beginning of the iteration.

Definition at line 195 of file IpPenaltyLSAcceptor.hpp.

Number Ipopt::PenaltyLSAcceptor::resto_pred_`[private]`

When called from the restoration phase, this is the required predicted reduction.

Definition at line 200 of file IpPenaltyLSAcceptor.hpp.

SmartPtr<PDSystemSolver> Ipopt::PenaltyLSAcceptor::pd_solver_`[private]`

Definition at line 204 of file IpPenaltyLSAcceptor.hpp.

The documentation for this class was generated from the following file:

- src/Algorithm/IpPenaltyLSAcceptor.hpp

All Classes Files Functions Variables Typedefs Enumerations Enumerator Friends Defines